# Application Architecture

## Topics Covered

- Requirements Analysis
- Quality Attributes
- C4 Model
- Solution Strategy
- Spring Framework
- Components and Containers
- Domain-Driven Design
- (Micro-)Services
- RESTful HTTP
- API Design
- Application Integration (Messaging)

## Goals

- [ ] Explain the characteristics of enterprise application as well as their design requirements
- [ ] Speficy Non-Functional Requirements in a SMART way
- [ ] Explain general and domain sepcific architectur patterns and evaluate architectural decisions
- [ ] Develop a service oriented architecture as well as mapping them to the needed technologies to implement it
- [ ] Being able to use established elements from consulting, desing and integrations methods
- [ ] Differentiate logical layers and physical tiers
- [ ] Domain-Driven Design in theory and practice
- [ ] Explain service oriented architectures as well as their implementation
- [ ] Enterprise Application Integration (EAI) principles, samples, technologies
- [ ] Methodology such as: NFRs, Systemcontex, Components Model, Architectural Decisions, Architecturally Evident Coding Styles 
